//
//  ViewController.m
//  ios交流群:592417062
//
//  Created by strk on 2017/4/6.
//  Copyright © 2017年 strk. All rights reserved.
//

#import "ViewController.h"
#import "QRCodeGenerator.h"
#define RandomColor [UIColor colorWithRed:arc4random_uniform(256)/255.0 green:arc4random_uniform(256)/255.0 blue:arc4random_uniform(256)/255.0 alpha:1]

@interface ViewController ()<UIActionSheetDelegate>
@property(nonatomic,strong)UIImageView*ErWeiMaView;


@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
  
    _ErWeiMaView=[[UIImageView alloc]initWithFrame:CGRectMake(40, 110, self.view.frame.size.width-80,[UIScreen mainScreen].bounds.size.height/2-60)];
    UITapGestureRecognizer *Taps00 = [[UITapGestureRecognizer alloc]
                                      initWithTarget:self action:@selector(shibieMa:)];
    _ErWeiMaView.userInteractionEnabled = YES;
    [_ErWeiMaView addGestureRecognizer:Taps00];
    [self.view addSubview:_ErWeiMaView];
    
    UIImage *image;
    image=_ErWeiMaView.image;
    NSString*tempStr;
    tempStr=[NSString stringWithFormat:@"https://www.baidu.com"];
    UIImage*tempImage=[QRCodeGenerator qrImageForString:tempStr imageSize:360 Topimg:image withColor:RandomColor];
    _ErWeiMaView.image=tempImage;
    

}
- (void)shibieMa:(UITapGestureRecognizer *)Ma
{
    
    
    UIActionSheet * sheet = [[UIActionSheet alloc] initWithTitle:@"请选择" delegate:self cancelButtonTitle:@"取消" destructiveButtonTitle:nil otherButtonTitles:@"识别二维码", @"保存二维码到相册",nil];
    
    [sheet showInView:self.view];
    
    
}
- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
    
    if (buttonIndex != actionSheet.cancelButtonIndex) {
        NSString* button = [actionSheet buttonTitleAtIndex:buttonIndex];
        if ([button isEqualToString:@"识别二维码"])
        {
            if(_ErWeiMaView.image){
                //1. 初始化扫描仪，设置设别类型和识别质量
                CIDetector*detector = [CIDetector detectorOfType:CIDetectorTypeQRCode context:nil options:@{ CIDetectorAccuracy : CIDetectorAccuracyHigh }];
                //2. 扫描获取的特征组
                NSArray *features = [detector featuresInImage:[CIImage imageWithCGImage:_ErWeiMaView.image.CGImage]];
                //3. 获取扫描结果
                CIQRCodeFeature *feature = [features objectAtIndex:0];
                NSString *scannedResult = feature.messageString;
                [self accordingQcode:scannedResult];
                
            }else {
                UIAlertView * alertView = [[UIAlertView alloc]initWithTitle:@"扫描结果" message:@"您还没有生成二维码" delegate:nil cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
                [alertView show];
            }
        }else if ([button isEqualToString:@"保存二维码到相册"])
        {
            UIImageWriteToSavedPhotosAlbum(_ErWeiMaView.image, self, @selector(imageSavedToPhotosAlbum:didFinishSavingWithError:contextInfo:), nil);
            
        }
    }
}

- (void)accordingQcode:(NSString *)str
{
    NSURL *url = [NSURL URLWithString:str];
    [[UIApplication sharedApplication]openURL:url];
    
}

- (void)imageSavedToPhotosAlbum:(UIImage *)image didFinishSavingWithError:(NSError *)error contextInfo:(void *)contextInfo
{
    //保存成功提示
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
